<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : Source: chart/series/PieSeries.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-boolean.html">boolean</a></li>
<li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="Checkbox.html"><i class="icon-shield" style="color: #0186d1"></i> Checkbox</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Combobox.html"><i class="icon-shield" style="color: #0186d1"></i> Combobox</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Datebox.html"><i class="icon-shield" style="color: #0186d1"></i> Datebox</a></li><li><a href="Datepicker.html"><i class="icon-shield" style="color: #0186d1"></i> Datepicker</a></li><li><a href="Filebox.html"><i class="icon-shield" style="color: #0186d1"></i> Filebox</a></li><li><a href="Filedropper.html"><i class="icon-shield" style="color: #0186d1"></i> Filedropper</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Numberbox.html"><i class="icon-shield" style="color: #0186d1"></i> Numberbox</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="PolarChart.html"><i class="icon-shield" style="color: #0186d1"></i> PolarChart</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Portal.html"><i class="icon-shield" style="color: #0186d1"></i> Portal</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Radiobutton.html"><i class="icon-shield" style="color: #0186d1"></i> Radiobutton</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Selectbox.html"><i class="icon-shield" style="color: #0186d1"></i> Selectbox</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Textbox.html"><i class="icon-shield" style="color: #0186d1"></i> Textbox</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Violation.html"><i class="icon-shield" style="color: #0186d1"></i> Violation</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header">Source: chart/series/PieSeries.js</h1>
              


    
    <section>
        <article>
            <pre class="prettyprint source"><code>/**
 * This document is a part of the source code and related artifacts
 * for uWeaver, an open source application development framework for
 * Enterprise Application Software.
 *
 *      http://www.uweaver.org
 *
 * Copyright 2016 Jason Lin
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

define(['underscore', 'jquery', 'd3', 'ss', 'uweaver/lang', 'uweaver/widget/Widget',
    'uweaver/data/Collection', 'uweaver/scale/LinearScale',
    'uweaver/formatter', 'uweaver/dom', 'uweaver/string'], function(_, $, d3, ss, lang, Widget, Collection, LinearScale, formatter, dom, string) {

    var declare = lang.declare;
    var Base = Widget;
    var RADIUS = 300, LABELFONTSIZE = 12;

    function initialize(config) {
        Base.prototype.initialize.apply(this, arguments);

        var defaults = {
            donut: 0,
            label: {
                display: 'auto'
            },
            style: {
                'fill': 'blue'
            },
            tooltips: {}
        };
        var cfg = this.cfg();

        _.defaults(cfg, defaults);

        this._component = d3.select(this.el);

        this.css({fill: 'none', stroke: 'none'});
        this.title(cfg.title);
        cfg.angleField &amp;&amp; (this._angleField = cfg.angleField);
        cfg.radiusField &amp;&amp; (this._radiusField = cfg.radiusField);
        cfg.labelField &amp;&amp; (this._labelField = cfg.labelField);
        cfg.angularAxis &amp;&amp; (this._angularAxis = cfg.angularAxis) ;
        cfg.radialAxis &amp;&amp; (this._radialAxis = cfg.radialAxis);
        this.donut(cfg.donut);
        (cfg.data) ? this.data(cfg.data, {render: false}) : this.data(new Collection(), {render: false});


    }

    function render(options) {
        var defaults = {
            hidden: false
        };

        options || (options = {});
        _.defaults(options, defaults);

        var cfg = this.cfg();
        var data = this._data;
        var angleField = this._angleField, radiusField = this.__radiusField, labelField = this._labelField;
        var angularAxis = this._angularAxis, radialAxis = this._radialAxis;
        var maxRadius = _.max(radialAxis.range());
        var margin = (maxRadius>=80 &amp;&amp; cfg.label.display!=='none') ? Math.min(maxRadius / 2 * 0.8, 80) : 0;
        maxRadius = maxRadius - margin;
        var theme = (data.size()&lt;=10) ? d3.scale.category10() : d3.scale.category20();

        this._component.selectAll('g').remove();

        var dataset = prepareDataset(data, angleField, radiusField, labelField, angularAxis, radialAxis, maxRadius, theme);

        layout.call(this);

        this._legend = [];

        _.each(dataset, function(datum, i) {
            var profile = {};

            profile.label = datum.label;
            profile.color = datum.color;
            profile.percentage = datum.percentage;

            this._legend.push(profile);
        }, this);

        var arcs = renderArc(this._component, dataset, maxRadius, this.donut());

        if(this.cfg().tooltips.display!=='none') {
            $(arcs.node()).find('path').on('mouseenter', _.bind(onMarkerHoverIn, this));
            $(arcs.node()).find('path').on('mouseleave', _.bind(onMarkerHoverOut, this));
        }


        renderLabel(this._component, dataset, maxRadius, margin);
        var value = data.reduce(function(sum, item) {
            var value = item.has(angleField) ? item.get(angleField) : 0;
            return sum + value;
        }, 0);
        renderDonut(this._component, value, maxRadius, this.donut());


        if(this.render === render) {
            this._isRendered = true;

            this.trigger('render', {
                data: {},
                context: this,
                source: this
            });
            options.hidden || this.show();
        }
        return this;
    }

    function prepareDataset(data, angleField, radiusField, labelField, angularAxis, radialAxis, maxRadius, theme) {
        var sum = data.reduce(function(sum, item) {
            var value = item.has(angleField) ? item.get(angleField) : 0;
            return sum + value;
        }, 0);
        var scale = new LinearScale();
        scale.range(angularAxis.range());
        scale.domain([0, sum]);
        var startAngle = 0;
        var dataset = data.map(function(item, i) {
            var angleValue = item.has(angleField) ? item.get(angleField) : 0;
            var endAngle = startAngle + scale.project(angleValue);
            var percentage = (endAngle - startAngle) / (Math.PI * 2);
            var radius, label;
            if(radiusField) {
                var radiusValue = item.has(radiusField) ? item.get(radiusField) : 0;
                radius = radialAxis.project(radiusValue);
            } else {
                radius = maxRadius;
            }
            if(labelField &amp;&amp; item.has(labelField)) {
                label = item.get(labelField);
            }
            var color = theme(i);
            var datum = {
                startAngle: startAngle,
                endAngle: endAngle,
                color: color,
                radius: radius,
                label: label,
                percentage: percentage,
                cid: item.cid
            };
            startAngle = endAngle;

            return datum;
        }, this);

        return  dataset;
    }

    function layout() {
        var layout = {
            title: {},
            pie: {},
            labels: {}
        };
        var dataset = this._dataset, radialAxis = this._radialAxis;
        var maxRadius = _.max(radialAxis.range()), title = this.title();

        //layout.title.fontSize = TITLEFONTSIZE * maxRadius / RADIUS;


        this._layout = layout;
    }

    function renderArc(el, dataset, maxRadius, donut) {
        var arc = d3.svg.arc()
            .outerRadius(function(datum) {return datum.radius})
            .innerRadius(maxRadius * donut)
            //.padAngle(Math.PI/20)
            .startAngle(function (datum) {return datum.startAngle;})
            .endAngle(function (datum) {return datum.endAngle;});

        var node = el.append('g');
        node.selectAll('path').data(dataset).enter()
            .append('path').attr('d', function(datum) {return arc(datum);})
            .style('fill', function(datum) {return datum.color}).attr('cid', function(datum) {return datum.cid});

        return node;
    }

    function renderDonut(el, value, maxRadius, donut) {

        if(donut&lt;=0) return;

        var color = d3.scale.category10();
        var pattern = (Math.round(value)===value) ? '#,##0' : '#,##0.00';
        var text = formatter.format(value, {pattern: pattern});
        var radius = maxRadius * donut;
        var fontSize = radius * 0.5;

        var node = el.append('text').text(text).style({
            'font-size': fontSize,
            stroke: 'none',
            fill: color,
            'text-anchor': 'middle'
        }).attr('transform', 'translate(0, ' + (fontSize / 2) + ')');

        var size = dom.sizing(node);
        if(size.width > radius * 2 * 0.8) {
            node.style('font-size', fontSize * 0.8);
        }

        return node;
    }

    function renderLabel(el, dataset, maxRadius, margin) {
        //var line = d3.svg.line.radial()
        //    .radius(function(datum) {return datum.radius;})
        //    .angle(function(datum) { return datum.angle;});
        if(margin===0) return;
        var line = d3.svg.line()
            .x(function(datum) {return datum.x})
            .y(function(datum) {return datum.y*-1});

        var node = el.append('g');
        var radius = maxRadius + 1;
        var color = d3.scale.category10();
        var lastPercentage = 0, radiusOffset = 0;
        node.selectAll('path').data(dataset).enter()
            .append('path').attr('d', function(datum) {
                var angle = (datum.startAngle + datum.endAngle)/2;
                var x0 = Math.sin(angle) * radius, y0 = Math.cos(angle) * radius;
                if(radiusOffset > 0 || (datum.percentage&lt;0.036 &amp;&amp; lastPercentage&lt;0.036)) {
                    radiusOffset = radiusOffset + 15 / Math.cos(angle);
                }
                var x1 = Math.sin(angle) * (radius + 15 + radiusOffset), y1 = Math.cos(angle) * (radius + 15 + radiusOffset);
                var x2 = (x1>=0) ? x1 + 5 : x1 - 5, y2 = y1;
                var dataset = [{x: x0, y: y0}, {x: x1, y: y1}];
                if(Math.abs(Math.cos(angle))>0.3) {
                    dataset.push({x: x2, y: y2});
                }
                var path = line(dataset);

                lastPercentage = datum.percentage;

                return path;
            }).style({fill: 'none', stroke: 'gray', 'stroke-width': 1});

        lastPercentage = 0; radiusOffset = 0;
        node.selectAll('text').data(dataset).enter().append('text').text(function(datum) {
                var text = "";
                if(margin>=80/2*0.8) text = text + datum.label;
                if(margin>=80*0.8) text = text + ": " + formatter.format(datum.percentage, {pattern: '#0.##%'});
                return text;
            }).attr('transform', function(datum){
                var angle = (datum.startAngle + datum.endAngle)/2;
                var x0 = Math.sin(angle) * radius, y0 = Math.cos(angle) * radius;
                if(radiusOffset > 0 || (datum.percentage&lt;0.036 &amp;&amp; lastPercentage&lt;0.036)) {
                    radiusOffset = radiusOffset + 15 / Math.cos(angle);
                }
                var x1 = Math.sin(angle) * (radius + 15 + radiusOffset), y1 = Math.cos(angle) * (radius + 15 + radiusOffset);
                var x2 = (x1>=0) ? x1 + 5 : x1 - 5, y2 = y1;
                var x = (Math.abs(Math.cos(angle))>0.3) ? x2 : x1, y = y1 - 3;

                x = (x>=0) ? x + 2 : x - 2; y = y * -1;

                lastPercentage = datum.percentage;


            return 'translate(' + x + ',' + y + ')';
            }).style('text-anchor', function(datum) {
                var angle = (datum.startAngle + datum.endAngle)/2;
                var textAnchor = 'start';
                if(angle>Math.PI) textAnchor = 'end';
                return textAnchor
            }).style({fill: color, 'font-size': '12px'});


        return node;
    }

    /**
     * Get or set the data.
     *
     * ##### Events:
     * + 'transition' - triggered after a new collection is bound. event.data => the collection.
     *
     * @memberof PieSeries#
     * @param {Collection} items - the data.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Boolean} [options.silent=false] - A false value will prevent the events from being triggered.
     * @param {Boolean} [options.render=true] - A false value will prevent the chart from being rendered.
     * @returns {PieSeries} this
     */
    function data(items, options) {
        if(!items) return this._data;

        options || (options = {});

        var defaults = {
            render: true
        };

        _.defaults(options, defaults);

        if(this._data) this.stopListening(this._data);

        this._data = items;

        this._dataset = items.toArray();

        this.listenTo(this._data, "update", _.bind(onItemsUpdate, this));

        options.render &amp;&amp; this.render();

        var event = {
            context: this,
            source: this,
            data: items
        };

        (options.silent) || this.trigger('transition', event);

        return this;
    }

    function onItemsUpdate() {
        this.refresh();
    }

    function refresh() {

    }

    function title(text) {
        if(!text) return this._title;

        this._title = text;
    }



    function angleField() {
        return this._angleField;
    }

    function radiusField() {
        return this._radiusField;
    }

    function angularAxis() {
        return this._angularAxis;
    }

    function radialAxis() {
        return this._radialAxis;
    }

    function color(index) {
        return this._color(index);
    }

    function donut(donut) {
        if(donut===undefined) return this._donut;

        this._donut = donut;

        return this;
    }

    function legend() {
        return this._legend;
    }

    function onMarkerHoverIn(event) {
        var marker = event.currentTarget;
        var $marker = $(marker);
        var cid = $marker.attr('cid');
        var rect = marker.getBBox();
        var x = rect.x + rect.width / 2;
        var y = rect.y + rect.height / 2;
        var cfg = this.cfg();
        var item = this.data().get(cid);

        var text = (cfg.tooltips.renderer) ? cfg.tooltips.renderer(item) : tooltipsRenderer.call(this, item);

        showTooltips.call(this, text, {x: x, y: y});
    }

    function tooltipsRenderer(item) {
        var angleField = this._angleField, labelField = this._labelField;
        var angularAxis = this._angularAxis;

        return "" + item.get(labelField) + ": " + angularAxis.format(item.get(angleField));
    }

    function onMarkerHoverOut(event) {
        hideTooltips.call(this);
    }

    function showTooltips(text, options) {
        var tooltips = getTooltips.call(this);
        var PADDING = 10;

        var textNode = tooltips.select('text').text(text);
        var textSize = dom.sizing(textNode);
        var calloutSize = {
            height: textSize.height + PADDING * 2,
            width: textSize.width + PADDING * 4
        };
        tooltips.select('path').attr('d', callout(calloutSize));
        textNode.attr({
            x: calloutSize.width / 2,
            y: calloutSize.height / 2 + textSize.height / 2 * 0.8
        });

        var x = options.x + 10;
        var y = options.y - calloutSize.height / 2;
        tooltips.attr('transform', 'translate(' + x + ', ' + y + ')')
            .style({display: ''});
    }

    function getTooltips() {
        var anchors = this._anchors;

        if(anchors.tooltips) return anchors.tooltips;

        var color = d3.scale.category10()();
        anchors.tooltips = this._component.append('g').style({
            'display': 'none'
        });

        anchors.tooltips.append('path').style({
            fill: 'white',
            'stroke-width': 2,
            'opacity': 0.8,
            stroke: color
        });
        anchors.tooltips.append('text').style({
            stroke: 'none',
            'text-anchor': 'middle',
            fill: color
        });

        return anchors.tooltips;
    }

    function callout(size) {
        var triangleWidth = size.height * 0.4, triangleHeight = triangleWidth * 10 / 16;
        var de = (size.height - triangleWidth) / 2, ga = de;
        var path = "M${triangleHeight} 0 L${width} 0 L${width} ${height} L${triangleHeight} ${height}" +
            " L${triangleHeight} ${heightMinusDE} L0 ${heightDivideTwo} L${triangleHeight} ${ga} Z";
        return string.substitute(path, {
            triangleHeight: triangleHeight,
            height: size.height,
            width: size.width,
            heightMinusDE: size.height - de,
            heightDivideTwo: size.height / 2,
            ga: ga
        });
    }

    function hideTooltips() {
        var anchors = this._anchors;
        anchors.tooltips.select('text').text("");
        anchors.tooltips.style({display: 'none'});
    }



    var props = {
        _data: undefined,
        _title: undefined,
        _angularAxis: undefined,
        _radialAxis: undefined,
        _angleField: undefined,
        _radiusField: undefined,
        _donut: undefined,
        _margin: 0,
        _legend: undefined,
        _layout: undefined,
        tagName: 'g'
    };

    var PieSeries = declare(Base, {
        initialize: initialize,
        render: render,
        title: title,
        data: data,
        angleField: angleField,
        radiusField: radiusField,
        angularAxis: angularAxis,
        radialAxis: radialAxis,
        color: color,
        donut: donut,
        legend: legend
    }, props);


    return PieSeries;

});</code></pre>
        </article>
    </section>




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Fri Aug 26 2016 10:58:19 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>
